#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"

#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

__fastcall TForm1::TForm1(TComponent* Owner) : TForm(Owner) {}

const int R=100;
int X,Y;
TStringList *List;
bool Flag[3];

void __fastcall TForm1::FormCreate(TObject *Sender) {
 DoubleBuffered = true;
 X = ClientWidth/2; Y = ClientHeight/2;
 Flag[0]=Flag[1]=Flag[2]=false;
 List = new TStringList ();
 List->Duplicates = dupIgnore;
 Draw = true;
}

#include <Math.hpp>
int __fastcall Distance (int x1,int y1,int x2,int y2) {
 return RoundTo(Power(Power(x1-x2,2)+Power(y1-y2,2),0.5),0);
}

void __fastcall TForm1::Panel() {
 TForm *ptForm = (TForm *)Form1;
 String S = (String)List->Count;
 TRect *R = new TRect (0,2,30,16);
 ptForm->Canvas->Brush->Color = clWhite;
 ptForm->Canvas->Pen->Color = clBlack;
 ptForm->Canvas->Font->Size = 10;
 ptForm->Canvas->FillRect(*R);
 for (int i=0; i<3; i++) {
  ptForm->Canvas->Font->Color = (Flag[i]==true?clRed:clBlack);
  ptForm->Canvas->TextOut(2+i*10,2,(String)(1+i));
  if (i<2) {
   ptForm->Canvas->MoveTo(10+i*10,2);
   ptForm->Canvas->LineTo(10+i*10,16);
  }
 }
 ptForm->Canvas->Brush->Color = clBlack;
 ptForm->Canvas->Font->Color = clSilver;
 ptForm->Canvas->TextOut(34,2,S);
}

void __fastcall TForm1::Make(int R) {
 TForm *ptForm = (TForm *)Form1;
 for (int x=X-R; x<X+R+1; x++)
 for (int y=Y-R; y<Y+R+1; y++) {
  int D=Distance (x,y,X,Y);
  int I =(D<R ? 255-RoundTo(D*255./R,0) : 0);
  if (I) ptForm->Canvas->Pixels[x][y] = (TColor)RGB //(I,I,I);
  ((Flag[0]==true?0:I),(Flag[1]==true?0:I),(Flag[2]==true?0:I));
 }
 Panel();
}

bool NoItemsNear(TStringList *List, int X, int Y, int D) {
 String Item;
 int xi,yi,pos,len;
 for (int i=0; i<List->Count; i++) {
  Item=List->Strings[i];
  len=Item.Length();
  pos=Item.Pos(",");
  xi=StrToInt(Item.SubString(1,pos-1));
  yi=StrToInt(Item.SubString(pos+1,len-pos));
  if (Distance(X,Y,xi,yi)<D) return false;
 }
 return true;
}

void __fastcall TForm1::FormClick(TObject *Sender) {
 if (Draw) {
  TPoint CursorPos; GetCursorPos(&CursorPos);
  X = CursorPos.x; Y = CursorPos.y;
  String NewItem=(String)X+","+(String)Y;
  if (List->IndexOf(NewItem)!=false) {
   if (NoItemsNear(List,X,Y,2*R)!=false) {
    List->Add(NewItem);
    Make(R);
   }
   else {
    Beep();
   }
  }
 }
}

void __fastcall TForm1::FormMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y) {
 if (Button == mbRight) {
  Canvas->Brush->Color = clBlack;
  Canvas->FillRect(Canvas->ClipRect);
  List->Clear();
  Panel ();
 }
 else if (Button == mbLeft) {
  if (Y>1 && Y<17 && X>-1 && X<30) {
   WORD Key;
   if (X<10) Key = '1';
   else if (X<20) Key = '2';
   else Key = '3';
   FormKeyDown(Sender, Key, Shift);
   Draw = false;
  }
  else Draw = true;
 }
}

void __fastcall TForm1::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift) {
 if (Key == VK_NUMPAD1) Key = '1';
 else if (Key == VK_NUMPAD2) Key = '2';
 else if (Key == VK_NUMPAD3) Key = '3';
 else if (Key<'1' && Key>'3') return;
 if (Key>='1' && Key<='3') {
  int i = Key-1-'0';
  bool NewCond = (Flag[i]==true?false:true);
  if (NewCond==false) Flag[i]=false;
  else {
   int kol=0;
   for (int j=0; j<3; j++) if (Flag[j]==true) kol++;
   if (kol<2) Flag[i]=true;
   else Beep();
  }
  Panel ();
 }
}

void __fastcall TForm1::FormPaint(TObject *Sender) {
 Panel();
}


